<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Exploration - Testing</title>
    <link type="text/css" rel="stylesheet" href="/explorer/local.css">
    <link type="text/css" rel="stylesheet" href="../Resources/css/global.css">
    <script src="https://kit.fontawesome.com/d611e648ec.js" crossorigin="anonymous"></script>
</head>
<body>



<script type="module">
    import * as d3 from "https://cdn.jsdelivr.net/npm/d3@7/+esm";
    import {GroundTruths} from "/explorer/groundtruths.js";
    import {FoundPatterns} from "/explorer/foundpatterns.js";
    import * as Patterns from "/explorer/patterns.js";
    import {GlyphCharter} from "/explorer/glyphCharter.js";
    import {Histogrammer} from "/explorer/Histogrammer.js";
    import {Legender} from "/explorer/legend.js";
    import {LineGrapher} from "/explorer/linegrapher.js";
    import {ScatterPlotter} from "/explorer/scatterPlotter.js";

    // The following pattern is synthetic data:
    // {
    //     "start": 75.78169437212097,
    //     "end": 81.01502102944121,
    //     "confidence": 0.2
    // },
    // !!!!!!!!

    //Set to false for deployment
    const DEBUG = false;
    const SHOWDEMO = true;

    if(!SHOWDEMO){
        d3.select("#demoButton").remove();
    }

    //Current color scheme
    const GROUNDTRUTHCOLOR = "#a6cee3";
    const FOUNDPATTERNCOLOR = "#1f78b4";
    const TIMESERIESCOLOR = "#b2df8a";

    //Load metadata file from drive at this point
    if(DEBUG){
        let metaData = await d3.json("/explorer/files/metadata.json");
    }

    //Filereader used to read files
    let seriesReader = new FileReader();
    let foundPatternReader = new FileReader();
    let groundTruthReader = new FileReader();
    let metaDataReader = new FileReader();

    //Booleans used to see if the right files are loaded
    let seriesLoaded = false;
    let foundPatternsLoaded = false;
    let groundTruthLoaded = false;
    let metaDataLoaded = false;

    d3.select("#timeSeriesFileInput").on("change", loadTimeSeries)
    d3.select("#foundPatternsFileInput").on("change", loadFoundPatterns)
    d3.select("#groundTruthFileInput").on("change", loadGroundTruths)
    d3.select("#metaDataFileInput").on("change", loadMetaData)

    //Data used in execute function
    let timeSeries;
    let seriesName;
    let foundPatternFile;
    let algoName;
    let groundTruthFile;
    let metaDataFile;

    //TODO check correct file formatting before going further in code
    function loadTimeSeries(){
        let file = document.getElementById("timeSeriesFileInput").files[0];
        seriesReader.addEventListener("load", parseSeriesFile, false);
        seriesName = file.name;
        seriesName = seriesName.substring(0, seriesName.length-4);
        if(file){
            seriesReader.readAsText(file);
        }
    }
    function loadFoundPatterns(){
        let file = document.getElementById("foundPatternsFileInput").files[0];
        algoName = file.name;
        foundPatternReader.addEventListener("load", parseFoundPatternsFile, false);
        if(file){
            foundPatternReader.readAsText(file);
        }
    }
    function loadGroundTruths(){
        let file = document.getElementById("groundTruthFileInput").files[0];
        groundTruthReader.addEventListener("load", parseGroundTruthFile, false);
        if(file){
            groundTruthReader.readAsText(file);
        }
    }

    function loadMetaData(){
        let file = document.getElementById("metaDataFileInput").files[0];
        metaDataReader.addEventListener("load", parseMetaData, false);
        if(file){
            metaDataReader.readAsText(file);
        }
    }

    function parseSeriesFile(){
        seriesLoaded = true;
        if(seriesLoaded && foundPatternsLoaded && groundTruthLoaded && metaDataLoaded){
            //Load time series data
            timeSeries = d3.csvParse(seriesReader.result, d3.autoType)
            //Execute rest of program
            execute(timeSeries, foundPatternFile, groundTruthFile);
        } else {
            //Load time series data
            timeSeries = d3.csvParse(seriesReader.result, d3.autoType);
        }
    }
    function parseFoundPatternsFile(){
        foundPatternsLoaded = true;
        if(seriesLoaded && foundPatternsLoaded && groundTruthLoaded && metaDataLoaded){
            //Load found pattern data
            foundPatternFile = JSON.parse(foundPatternReader.result);
            //Execute rest of program
            execute(timeSeries, foundPatternFile, groundTruthFile);
        } else {
            //Load found pattern data
            foundPatternFile = JSON.parse(foundPatternReader.result);
        }
    }
    async function parseGroundTruthFile() {
        groundTruthLoaded = true;
        if (seriesLoaded && foundPatternsLoaded && groundTruthLoaded && metaDataLoaded) {
            //Load ground truth data
            groundTruthFile= JSON.parse(groundTruthReader.result);
            //Execute rest of program
            execute(timeSeries, foundPatternFile, groundTruthFile);
        } else {
            groundTruthFile= JSON.parse(groundTruthReader.result);
        }
    }

    async function parseMetaData() {
        metaDataLoaded = true;
        if (seriesLoaded && foundPatternsLoaded && groundTruthLoaded && metaDataLoaded) {
            //Load ground truth data
            metaDataFile= JSON.parse(metaDataReader.result);
            //Execute rest of program
            execute(timeSeries, foundPatternFile, groundTruthFile);
        } else {
            metaDataFile= JSON.parse(metaDataReader.result);
        }
    }

    d3.selectAll(".content").attr("hidden", "hidden");

    async function loadDemoFiles(){
        //Import files
        let groundTruthFile = await d3.json("/explorer/files/multitrackgroundtruths.json", function(d) {
            return {
                time_start: +d.time_start,
                time_end: +d.time_end
            }
        });



        let foundPatternFile = await d3.json("/explorer/files/dtw_before_threshold.json", d=>{
            return {
                time_start: +d.time_start,
                time_end: +d.time_end,
                confidence: +d.confidence
            }
        });
        algoName = "dtw_before_threshold.json";
        let timeSeries = await d3.csv("/explorer/files/EEG_Eye_State.csv", d3.autoType);
        seriesName = "EEG_Eye_State";
        execute(timeSeries, foundPatternFile, groundTruthFile);
    }

    d3.select("#demoButton").on("click", loadDemoFiles);

    if(DEBUG){
        loadDemoFiles();
    }


    function execute(timeSeries, foundPatternFile, groundTruthFile) {

        d3.selectAll(".content").attr("hidden", null);
        d3.selectAll(".file").remove();
        d3.select("#demoButton").remove();

        d3.select("#algonameTarget").append("h1")
            .attr("class", "title")
            .text(algoName);

        d3.select("#timeSeriesNameTarget").append("a")
            .attr("class", "navbar-item")
            .attr("href", "#")
            .text(seriesName);

        //Instantiate groundTruth array class and foudnPattern array class
        let groundTruths = new GroundTruths();
        let foundPatterns = new FoundPatterns();

        groundTruthFile.forEach((truth) => {
            groundTruths.push(new Patterns.GroundTruth(truth.time_start, truth.time_end, GROUNDTRUTHCOLOR));
        })

        foundPatternFile.forEach((pattern) => {
            foundPatterns.push(new Patterns.FoundPattern(pattern.time_start, pattern.time_end, pattern.confidence, FOUNDPATTERNCOLOR));
        })

        //Setup linegraph first to be able to pass the zoom method to the glyph charter
        const histoMargin = {top: 10, right: 10, bottom: 30, left: 7},
            histowidth = 500 - histoMargin.left - histoMargin.right,
            histoheight = 400 - histoMargin.top - histoMargin.bottom;
        let histoSvg = d3.select("#histoTarget").append("svg")
            .attr("width", histowidth + histoMargin.left + histoMargin.right)
            .attr("height", histoheight + histoMargin.top + histoMargin.bottom)
            .append("g")
            .attr("transform", "translate(" + histoMargin.left + "," + histoMargin.top + ")");
        let histoGrammer = new Histogrammer(histoSvg, histoheight, histowidth, foundPatterns, groundTruths, FOUNDPATTERNCOLOR);

        let lineGraphMargin = {top: 10, right: 0, bottom: 30, left: 7},
            lineGraphWidth = 850 - lineGraphMargin.left - lineGraphMargin.right,
            lineGraphHeight = 450 - lineGraphMargin.top - lineGraphMargin.bottom;
        let lineGraphSvg = d3.select("#lineGraphTarget").append("svg")
            .attr("width", lineGraphWidth + lineGraphMargin.left + lineGraphMargin.right)
            .attr("height", lineGraphHeight + lineGraphMargin.top + lineGraphMargin.bottom)
            .append("g")
            .attr("transform", "translate(" + lineGraphMargin.left + "," + lineGraphMargin.top + ")");

        let miniMapSvg = d3.select("#miniMapTarget").append("svg")
            .attr("width", lineGraphWidth + lineGraphMargin.left + lineGraphMargin.right)
            .attr("height", 75);

        let lineGrapher = new LineGrapher(lineGraphSvg, lineGraphHeight, lineGraphWidth, timeSeries, groundTruths,
            foundPatterns, TIMESERIESCOLOR, GROUNDTRUTHCOLOR, FOUNDPATTERNCOLOR, miniMapSvg);

        const scatterMargin = {top: 10, right: 10, bottom: 35, left: 7},
            scatterHeight = 400 - scatterMargin.top - scatterMargin.bottom,
            scatterWidth = 500 - scatterMargin.left - scatterMargin.right;
        //Minus 100 from the width, just to have space for the color legend
        let scatterSVG = d3.select("#scatterPlotTarget").append("svg")
            .attr("width", scatterWidth + scatterMargin.left + scatterMargin.right)
            .attr("height", scatterHeight + scatterMargin.top + scatterMargin.bottom)
            .append("g")
            .attr("transform", "translate(" + scatterMargin.left + "," + scatterMargin.top + ")");

        let scatterPlotter = new ScatterPlotter(scatterSVG, scatterHeight, scatterWidth);

        //Setup svg for glyphchart
        const glyphChartMargin = {top: 0, right: 30, bottom: 30, left: 5},
            glyphChartWidth = 600 - glyphChartMargin.left - glyphChartMargin.right,
            glyphChartHeight = 500 - glyphChartMargin.top - glyphChartMargin.bottom;

        const glyphChartSvg = d3.select("#glyphChartTarget").append("svg")
            .attr("width", glyphChartWidth + glyphChartMargin.left + glyphChartMargin.right)
            .attr("height", glyphChartHeight + glyphChartMargin.top + glyphChartMargin.bottom)
            .append("g")
            .attr("transform", "translate(" + glyphChartMargin.left + "," + glyphChartMargin.top + ")");

        const legendMargin = {top: 30, right: 30, bottom: 0, left: 5},
            legendWidth = 600 - legendMargin.left - legendMargin.right,
            legendHeight = 150 - legendMargin.top - legendMargin.bottom;

        const legendSvg = d3.select("#legendTarget").append("svg")
            .attr("width", legendWidth + legendMargin.left + legendMargin.right)
            .attr("height", legendHeight + legendMargin.top + legendMargin.bottom)
            .append("g")
            .attr("transform", "translate(" + legendMargin.left + "," + legendMargin.top + ")");

        let glyphCharter = new GlyphCharter(glyphChartSvg, glyphChartWidth, glyphChartHeight, groundTruths,
            foundPatterns, timeSeries, 0.1, lineGrapher, scatterPlotter);



        let legender = new Legender(legendSvg, legendWidth, legendHeight, FOUNDPATTERNCOLOR, TIMESERIESCOLOR, GROUNDTRUTHCOLOR);

        d3.select("#sortingselect").on("change", function () {
            let newSorting = d3.select(this).property("value");
            glyphCharter.updateSorting(newSorting);
        })

        //Declare functionality for selecting confidence cutoff in histogram
        histoSvg.style("pointer-events", "bounding-box").on("mousemove", (event, d) => {
            let realX = event.offsetX - histoMargin.left;
            if ((realX <= histowidth) && (realX >= 0)) {
                histoGrammer.hoverline.attr("x1", realX).attr("x2", realX);
                histoGrammer.newCutoffText.text("Selected: " + (Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
            } else if (realX > histowidth) {
                histoGrammer.hoverline.attr("x1", histowidth).attr("x2", histowidth);
                histoGrammer.newCutoffText.text("Selected: " + (Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
            } else if (realX < 0) {
                histoGrammer.hoverline.attr("x1", 0).attr("x2", 0);
                histoGrammer.newCutoffText.text("Selected: " + (Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
            }
        }).on("click", (event, d) => {
            let realX = event.offsetX - histoMargin.left;
            if ((realX <= histowidth) && (realX >= 0)) {
                histoGrammer.currentSelectionLine.transition().duration(100).attr("x1", realX).attr("x2", realX);
                histoGrammer.currentCutoffText.text("Current cutoff: " + (Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
                glyphCharter.setConfidenceCutoff((Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
                lineGrapher.updateConfidenceThreshold((Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
            } else if (realX > histowidth) {
                histoGrammer.currentSelectionLine.transition().duration(100).attr("x1", realX).attr("x2", realX);
                histoGrammer.currentCutoffText.text("Current cutoff: " + (Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
                glyphCharter.setConfidenceCutoff((Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
                lineGrapher.updateConfidenceThreshold((Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
            } else if (realX < 0) {
                histoGrammer.currentSelectionLine.transition().duration(100).attr("x1", realX).attr("x2", realX);
                histoGrammer.currentCutoffText.text("Current cutoff: " + (Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
                glyphCharter.setConfidenceCutoff((Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
                lineGrapher.updateConfidenceThreshold((Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
            }

            histoGrammer.lowLight(realX);
        })


        let cardMargin = 20;
        let cardPadding = 15;
        let cardWidth = (glyphChartWidth + glyphChartMargin.left + glyphChartMargin.right) + 2 * cardMargin;
        d3.select("#glyphCard")
            .style("width", cardWidth + "px")
            .style("margin", cardMargin + "px")
            .style("padding", cardPadding + "px");

        d3.select("#toggleShadowLineSwitch")
            .on("change", d => {
                glyphCharter.toggleShadowLines()
            });

        d3.select("#vizTechSelect")
            .on("change", function (d) {
                lineGrapher.setNewVizTechnique(d3.select(this).property("value"));
            })

        d3.select("#trackSelectorButton").on("click", d => {
            let values = [];
            d3.select("#trackSelector").selectAll("option:checked").each(function () {
                values.push(this.value)
            });
            lineGrapher.setSelectedColumns(values);
            glyphCharter.resetZoomLineGraph();
            lineGrapher.miniMapper.reset();
        })

        d3.select("#toggleConfidenceViz").on("click", d => {
            glyphCharter.toggleDrawMethod();
        })

        d3.select("#toggleIDSwitch").on("change", d => {
            glyphCharter.toggleIDS();
        })

        d3.select("#resetZoomButton").on("click", d => {
            glyphCharter.resetZoomLineGraph();
            lineGrapher.miniMapper.reset();
        })

        //Toggles for the tabs in data filtering. 0 means confidence histogram, 1 means scoring plot.
        let currentTabSelection = 0;
        d3.select("#confTabButton").on("click", d => {
            if(currentTabSelection === 1){
                d3.select("#scoreTabList").attr("class", "null");
                d3.select("#confTabList").attr("class", "is-active");
                d3.select("#scatterplotContainer").style("display", "none");
                d3.select("#histogramContainer").style("display", null);
                currentTabSelection = 0;
            }
        })
        d3.select("#scoreTabButton").on("click", d => {
            if(currentTabSelection === 0){
                d3.select("#confTabList").attr("class", "null");
                d3.select("#scoreTabList").attr("class", "is-active");
                d3.select("#histogramContainer").style("display", "none");
                d3.select("#scatterplotContainer").style("display", null);
                currentTabSelection = 1;
            }
        })
    }


</script>

<nav class="navbar is-primary" role="navigation" aria-label="main navigation">
    <div class="navbar-brand">
        <a class="navbar-item" href="../index.html">
            <svg id="navbarImg"xmlns="http://www.w3.org/2000/svg" enable-background="new 0 0 3936.9299 5000" version="1.1" viewBox="0 0 3936.9 5e3" width="30px" height="50px">
                <path d="m3797.8 0.4774c-0.2725-0.1623-0.5398-0.3211-0.8035-0.4774h-3656.3c-6.2446 2.6145-11.418 6.1944-16.419 11.109-25.412 24.962-24.945 71.525 15.555 106.14 57.54 49.191 137.9 38.282 317.73 37.67 1757.7-30.347 3174.2 6.3931 3262.7-9.9745 36.619-6.0012 69.218-28.34 87.574-54.469 25.6-36.435 14.37-75.485-10.028-90.002z"/> <path d="m3235.9 3022.7c-22.515-23.751-127.41-122.73-76.524-183.29 13.928-16.587 37.924-28.69 59.49-30.251 33.317-2.4104 57.202 15.754 80.069 36.943-15.52-7.2202-45.968-27.168-80.044 3.1833-23.721 21.116-28.473 63.09 0.0764 90.569 31.301 30.135 78.82 21.753 107.29-10.857 47.404-54.298 10.072-137.55-34.334-173.79-35.366-28.862-74.098-34.237-118.18-30.077 130.55-159.9 143.09-292.94 0.0452-455.11l20.844 1.5405c126.24 9.0327 186.03-143.23 133.36-201.73-14.192-15.764-34.573-27.103-56.017-28.196-61.591-3.1226-91.488 66.498-48.033 107.98 12.27 11.711 23.554 17.37 40.726 16.389 12.235-0.7017 22.867-7.4646 33.393-13.18-25.496 23.594-47.494 36.292-83.755 34.059-39.501-2.4219-75.975-36.695-67.967-88.805 28.168-183.3 936.86-725.53 759.34-1375.1-21.764-79.647-53.774-155.17-101.4-223.05-54.837-78.162-131.44-151.4-214.7-198.77 17.248-28.803 33.46-55.688 57.512-79.564 30.85-30.621 81.241-62.932 85.266-70.349-224.61 47.129-1488.8 22.378-1544.2 33.202 95.845 24.451 355.14 70.881 619.17 309.94 35.326 31.985 64.096 70.428 98.695 102.5-24.576-52.686-30.067-101.02-10.068-156.13 31.634-87.158 99.717-147.74 182.65-186.2 104.81-48.599 223.3-51.897 336.59-41.808 16.546 1.4736 46.228 0.8873 61.102 7.1994l3.7117 2.1845c-177.75-8.0064-372.88-17.579-501.17 110.08-45.419 45.191-82.509 108.8-82.57 174.45-0.0867 92.715 66.227 166.58 111.43 242.64-34.512-104.09-47.205-203.37 3.8748-304.6 42.404-84.043 116.75-151 206.56-180.59 68.266-22.496 152.34-27.715 222.47-12.744-42.938 2.2385-85.84 2.8023-128.49 8.8034-184.95 26.028-335.53 172.66-323.95 358.61 10.758 172.83 148.11 353.71 339.82 339.42 54.547-4.0629 95.39-31.141 137.31-63.313 9.0359 274.33-151.97 515.46-323.21 716.13-111.22 130.34-216.74 214.17-295.81 427.27-15.967 43.029-32.88 89.552-39.434 135.1-98.451-0.8184-182.54 22.359-253.86 93.712-201.73 201.8-58.337 546.09 242.98 551.46 74.026 296.51 211.6 434.39 445.69 700.21 111.47 137 255.09 406.23 241.89 582.96-88.65-106.6-282.09-75.571-380.5 10.079-64.595 56.214-109.52 136.42-114.67 222.83-6.0459 101.58 21.235 203.55 90.711 280.47 131.82 145.96 315.67 122.62 345.49 128.22-39.556 5.7812-78.813 10.267-118.86 7.0933-162.16-12.847-303.49-141.55-327.85-316.81-6.7886-48.821-4.1292-95.751 0.168-144.56-8.2327 10.485-14.045 24.316-20.935 35.859-34.669 58.066-65.947 120.09-57.11 190.02 8.1003 64.081 56.357 124.27 106.65 161.81 141.03 105.29 313.66 104.28 481.03 96.107v1.1597c-12.066 6.1777-44.011 5.8169-58.396 6.8037-99.732 6.834-194.25 7.1597-290.55-23.559-142.23-45.362-280.46-164.44-247.16-316.91 4.0884-18.184 14.945-36.836 17.68-54.654-16.044 15.55-29.981 34.659-44.57 51.679l-67.814 71.958c-127.42 123.14-293.43 222.14-463.99 270.79-48.186 13.745-97.266 20.208-145.91 31.288 54.246 6.4546 1022.8-5.8682 1530.5 13.913-20.376-18.728-43.777-33.551-63.618-53.199-23.534-23.3-41.84-50.988-63.003-76.352 194.66-141.83 307.23-333.24 336.39-488.46 73.79-392.82-283.83-756.82-691.3-1184.6zm-127.11-284.54c-2.4255 1.9221-4.8206 2.8882-7.6274 4.1494-0.75-10.849 23.472-23.747 46.391-69.924 63.228-127.44 63.833-298.02-57.212-430.23 128.03 68.626 159.77 364.11 18.448 496.01zm-363.01-1.0335c-194.51-29.116-262.73-243.19-168.01-380.61 58.284-84.553 173.39-125.13 271.81-95.83 98.426 29.304 172.59 126.23 175.13 228.9 3.4021 137.19-118.81 271.51-278.94 247.54zm479.83 1892c-147.35-61.148-205.78-235.8-147.38-368.47 42.427-96.402 177.58-168.96 291.24-117.74 26.834 12.098 56.055 35.946 65.942 66.776-8.0544-3.1016-18.077-13.832-26.32-18.56-34.777-19.948-78.213-25.374-117.64-20.599-96.98 11.762-182.03 105.22-166.92 221.41 7.5005 57.679 42.155 118.67 88.84 153.68 246.87 185.17 758.91-228.83 352.09-858.74-45.892-71.048-93.081-139.15-146.44-204.85-165.68-204-399.82-436.3-442.95-700.92-17.737 10.196-36.216 17.538-55.259 24.886 61.631 360.29 513.89 640.18 668.67 1100.4 30.743 91.395 53.132 276.52-15.331 414.15-64.638 129.94-195.13 197.49-321.37 131.9 31.304 6.1938 59.302 9.9668 91.215 4.8105 157.16-25.392 231.13-212.07 225.36-372.46-6.0547-168.45-88.924-336.64-181.18-476.4-197.66-299.46-449.27-473.78-504.36-806.83 318.77-146.39 250.08-524.97 2.4512-608.82-1.1631-8.7549 0.3909-13.181 17.467-88.082 73.658-279.21 288.02-403.06 493.27-738.92 93.595-153.18 171.47-322.64 162.86-506.43-10.175-217.03-134.34-323.3-264.58-330.77-16.953-0.9713-34.659 1.256-51.633 2.2678l50.753-14.965c228.79-43.739 548.25 291.61 88.744 960.49l-156.75 204.57c-105.2 126.4-267.22 277.58-300.85 502.82 24.217 11.13 38.143 16.977 58.229 30.734 9.4543-212.11 218.86-441.94 335.05-575.64l151.96-182.56c186.39-241.08 337.27-539.93 200.01-812.4-47.799-94.896-140.21-190.52-243.06-224.06-65.952-21.508-142.32-21.308-204.69 11.35-208.77 109.32-63.67 498.63 199.65 357.68l-0.6204 1.8609c-19.954 32.982-64.315 61.061-101.65 68.795-100.78 20.879-234.35-70.937-258.4-209.22-24.749-142.28 84.012-277.09 227.54-299.87 189.85-29.413 437.52 146.19 481.72 413.46 51.36 310.6-177.63 616.39-383.08 854.57-159.28 184.64-275.88 306.68-338.99 482.07-28.43 79.008-23.17 99.992-33.785 114.76-5.6345 0.8999-10.592 2.7458-15.952 4.6377l-0.717 4.1189c21.591 19.948 42.307 39.165 60.445 62.434 114.9 147.38 87.086 364.04-63.542 479.63l0.3003 3.4475 9.9153 3.1169c16.618 8.9041 18.006 49.584 22.456 67.219 84.332 334.37 629.77 722.26 735.65 1147.8 95.158 382.45-243.05 764.11-538.37 641.55zm158.14-270.02c-10.562 33.676-46.451 54.853-79.789 50.627-69.334-8.7891-87.691-104.9-26.373-138.57 27.228-14.954 63.853-10.31 86.488 10.964 20.37 19.145 27.999 50.432 19.674 76.983zm-3.4968-3665c-6.676 12.818-16.642 23.892-29.075 31.304-64.244 38.297-142.82-30.627-113.4-99.271 13.074-30.505 46.954-50.701 80.007-47.693 51.995 4.7324 90.53 61.775 62.463 115.66z"/> <path d="m360.27 4699.4c-37.598 26.65-64.447 57.74-97.708 88.972-13.465 12.646-29.01 23.132-41.977 36.246 37.726 3.3843 50.45 2.2358 416.91-7.353 1076.5-3.5513 1091.7-1.8311 1100.9-6.3613-11.823-8.4614-46.65-9.585-61.788-12.616l-72.131-17.635c-169.04-48.857-345.48-145.09-479.41-274.15-65.814-63.427-90.149-106.04-98.786-110.91 5.0138 17.833 10.668 36.221 13.134 54.613 15.031 112.09-55.894 246.09-237.02 296.15-100.21 27.698-209.84 32.539-313.37 36.795-26.925 1.1035-68.668 6.2749-94.348-2.6948 249.85-19.731 456.34-15.135 575.44-148.59 75.989-85.163 78.634-211.84-3.1373-307.45 5.3341 108.87-13.242 203.71-88.978 286.63-90.931 99.554-224.85 137.74-360.01 133.67 29.198-7.1343 62.337-5.7607 92.583-11.217 117.08-21.113 229.1-75.421 292.26-180.44 166.7-277.16-104.04-567.88-349.02-502.81-37.095 9.8496-64.849 26.381-97.144 45.907 4.3324-63.364 10.033-124.49 26.213-186.23 123.75-472.18 599.16-682.03 649.99-1095.4-27.663-2.4155-54.232-5.6951-81.238-12.311-73.397 425.15-477.31 622.27-637.34 1063-122 335.98 28.551 562.42 174.34 588.02 33.79 5.9341 64.793-1.1035 97.815-8.1567-145.71 103.44-437.32-46.731-357.75-469.21 9.2393-49.091 24.179-92.852 42.495-139.26 159.1-403.08 513.93-619.33 615.95-945.78 10.902-34.878 20.167-67.417 21.037-104.13l-49.747-23.666-15.229 72.838c-90.656 347.21-354.8 497.37-603.96 903.21-40.37 65.754-78.518 133.64-101.89 207.6-100.63 318.4 94.495 589.65 270.97 628.49 240.46 52.94 379.81-158.37 274.65-310-28.984-41.789-77.791-79.652-129.06-87.594-46.233-7.1597-97.851 9.7529-134.67 37.741l-17.035 13.607c36.473-83.528 68.822-100.67 140.79-107.79 231.63 18.231 320.44 301.15 143.2 449.78-68.48 57.43-156.98 78.787-245 70.494-109.13-10.287-235.13-88.214-318.85-257.65-182.55-369.52 64.204-685.76 365.78-1043.5 128.84-152.81 259.56-299.45 312.12-497.76 6.2597-23.615 9.5804-47.606 13.867-71.612 1.6221-9.092 5.5833-21.5 3.5442-30.276-62.708-45.132-193.5-246.25-30.342-456.68l28.858-33.205c-23.08-132.81-54.186-206.97-123.29-316.91-169.53-269.7-740.33-735.41-617.98-1215.7 47.374-185.97 183.82-333.73 369.44-365.52 233.77-40.044 433.08 209.39 283.27 419.11-32.793 45.897-93.147 90.579-150.12 99.097-80.605 12.044-153.06-29.254-179.16-86.043 33.114 30.49 63.37 50.479 110.52 48.531 171.68-7.0999 289.2-237.31 139.2-368.48-97.488-85.249-286.72-75.899-416.95 73.646-84.732 97.297-125.65 230.03-115.91 358.24 33.521 441.12 479.51 770.64 644.09 1067.3 46.874 84.488 76.916 174.1 95.924 268.51l55.91-31.796c-28.738-106.99-46.65-173.05-121.41-291.65-122.37-194.12-457.91-479.57-555.78-912.1-91.418-404.01 208.11-540.81 343.19-461.08-67.275-7.6019-126.02 6.4327-179.5 48.954-138.13 109.82-143.49 291.96-97.571 463.78 56.159 210.11 173.07 388.84 308.92 555.74 140.03 172.05 249.96 282.19 317.56 481.68 10.953 32.31 18.082 66.309 26.686 99.326 23.126-7.2205 45.684-12.621 69.695-15.921-25.161-132.41-84.264-263.72-166.13-370.74l-211.05-250.56c-150.79-191-273.32-433.14-286.65-666.52 30.084 42.38 84.174 67.185 134.84 74.556 140.48 20.436 322.61-93.258 348.59-292.05 12.026-92.008-7.9379-190.13-65.129-264.34-68.495-88.871-180.29-125.07-287.46-137.73l-77.343-4.5109-0.5847-2.627c300.55-13.718 441.84 135.11 451.28 338.12 2.3695 51.023-9.331 98.192-21.154 147.14 50.855-83.333 103.99-169.64 80.48-272.13-16.312-71.102-71.836-131.99-133.15-168.99-98.999-59.738-196.12-56.594-453.89-77.273 54.267-3.5333 109-0.0126 163.25 2.7551 130.64 6.666 249.21 9.7363 350.85 98.372 100.48 87.624 114.38 209.11 66.883 296.99 45.165-48.898 89.171-97.093 138.8-141.69 136.07-122.27 303.14-213.16 477.51-267.42 37.07-11.534 75.05-16.7 112.23-27.033l-1541-23.765c42.431 33.742 96.922 60.307 139.24 140.47-168.21 119.76-300.83 283.45-335.44 492.2-75.234 453.9 404.23 883.06 702.39 1186.5 35.49 39.102 89.901 91.504 77.75 157.43-15.124 82.111-97.726 71.64-119.13 40.563l-1.3882-7.6277c8.3037-9.7683 20.249-9.2495 32.488-12.082 89.873-20.816 34.056-132.12-49.63-111.83-95.9 23.248-105.28 218.14 104.61 228.25-98.11 163.69-125.01 225.64-25.7 387.4 13.079 21.311 26.34 42.389 43.385 60.801-172.49-1.322-225.91 135.47-153.15 206.83 31.508 30.905 81.59 24.106 108.83-4.9221 17.953-19.136 20.548-53.642-5.7106-76.616-16.689-14.609-37.004-13.068-57.206-17.441-0.3-6.0969-0.1221-5.1001 3.8594-9.3159 29.167-30.902 80.742-28.648 109.16-0.188 28.566 28.596 14.265 84.088-6.8238 118.86-99.917 164.82-594.38 517.42-736.36 968.4-18.428 58.523-32.519 120.49-33.764 182.04-3.5669 175.96 87.529 350.36 186.9 460.77 51.516 57.232 108.73 105.14 171.84 149zm191.27-396.98c20.664-35.596 65.518-47.454 99.208-33.254 30.529 12.869 50.893 46.566 48.088 79.578-2.8043 33.011-28.56 62.792-60.822 70.325-67.574 15.78-119.06-60.509-86.474-116.65zm4.7956-3672.7c25.966-58.788 99.881-61.907 134.68-18.76 20.927 25.945 22.924 65.509 4.7161 93.43-41.002 62.872-142.35 35.506-146.13-39.458-0.6101-12.09 1.8551-24.165 6.7343-35.212zm185.04 1799.8c11.213-111.48 68.179-164.53 105.5-205.74 11.243-12.413 22.013-27.093 33.82-38.692l2.1155-1.5964c-3.4885 18.539-8.6094 21.275-66.817 91.378-94.169 119.5-86.003 273.57-16.252 402.66 23.808 44.067 62.078 79.698 85.133 123.47l-2.6542 1.0017c-60.019-71.934-161.97-162.52-140.85-372.48z"/> <path d="m2611.2 1913.5c595.13-491.01 565.69-1023.8 121.99-1416.1-219.85-194.38-524.18-306.82-818.28-288.38-70.097 3.285-140.53 10.549-208.92 26.824-232.45 55.318-440.92 188.97-600.85 364.88-387.49 426.21-262.96 884.5 167.35 1269.8 159.15 142.51 466.44 304.18 479.71 541.8 8.3698 149.89-53.51 274.08-152 383.17-174.87 193.69-636.66 458.33-717.09 930.19-114.05 668.86 661.33 1202.6 1372 1023.2 433.42-109.39 745.91-463.67 802.97-741.66 13.313-64.839 14.813-131.38 10.841-197.29-19.883-330.05-254.28-582.43-489.03-789.25-166.57-146.75-378.23-298.17-394.89-539.67-18.498-268.12 212.92-391.51 426.22-567.49zm-481.13 544.62c4.0679 104.74 37.507 205.61 96.046 292.57 174.76 259.58 762.52 557.88 782.82 1089 2.3137 60.441-1.7747 123.04-15.88 181.94-72.959 304.57-410.3 643.46-854.56 714.13-794.06 126.38-1582.9-658.92-1017.7-1395.2 268.89-350.24 701.51-508.28 688.19-912.34-7.7802-236.08-235.85-386.67-403.47-517.17l-145.68-124.45c-176.89-166.24-327.42-384.5-334.08-635.41-1.3627-51.272 1.3882-102.18 12.25-152.42 68.591-317.22 411.97-610.49 732.98-706.26 674.61-201.27 1318.4 344.19 1334.5 818.22 2.9646 87.615-15.321 170.81-45.134 252.66-213.44 586.02-847.5 651.12-830.26 1094.7z"/> <path d="m1883.7 920.24c77.869 144.16 58.889 142.14 87.737 235.87 15.804-104.93 35.986-148.71 80.72-232.87 118.89-223.67 224.84-308.08 322.33-395.08 12.809-10.933 34.659-24.378 43.741-37.899-11.293 2.2939-243.48 110.59-367.62 253.71-30.826 35.537-62.47 72.075-68.805 186.28-3.3054 59.703-2.858 118.22-10.877 177.64-24.412-76.526 1.2092-203.82-40.538-296.78-13.211-29.412-33.266-53.55-54.669-77.394-76.636-85.377-181.16-150.99-281.05-205.73-27.361-14.992-49.224-29.946-78.289-40.105 32.434 39.949 214.02 148.56 367.33 432.35z"/> <path d="m1337.4 883.97c57.628 47.423 135.86 59.907 206.74 75.111 126.61 27.154 280.4 63.583 360.03 174.74l3.2899 0.8799c-15.367-34.441-44.891-61.478-73.789-84.61-158.48-126.86-391.76-190.52-490.43-265.22-55.941-42.353-98.598-96.188-128.27-159.41 9.2397 95.126 46.492 196.02 122.43 258.51z"/> <path d="m2039.9 1130.8c3.6411-2.8121 2.1868-1.2917 4.9784-5.1307 132.26-181.97 441.8-137.89 554.21-239.66 66.334-60.049 102.11-154.39 106.26-242.23-85.467 160.08-203.83 200.44-381.44 279.12-82.093 36.363-250.1 120.16-284.01 207.9z"/> <path d="m2400.2 734.84c-72.517 61.6-172.44 62.846-244.99 121.43-70.244 56.718-101.97 140.55-131.86 222.67-9.2241 25.349-21.245 52.833-24.128 79.759 8.323-11.744 26.906-80.252 69.177-126.79 94.454-103.98 251.68-125.08 336.32-239.02 23.066-31.054 56.673-94.484 50.947-133.99-11.16 11.107-18.857 44.858-55.462 75.94z"/> <path d="m1841.2 1003c79.046 70.213 92.075 146.94 101.66 154.63-5.6493-31.003-18.438-59.017-29.711-88.21-32.636-84.503-66.761-166.51-144.27-220.12-81.413-56.289-160.04-50.712-224.23-96.585-22.837-16.328-44.418-37.522-58.346-62.057-2.7-4.7597-11.624-25.008-16.079-26.279-5.4666 40.233 20.335 85.779 43.767 116.78 80.908 107.04 229.27 134.83 327.22 221.84z"/> <path d="m1756.2 1392.4c116.87 85.449 171.15 164.51 212.32 279.29 69.857-161.59 158.57-288.61 494.89-421.61 230.96-91.335 526.9-116.36 480.72-220.84-34.228-77.466-256.12-138.32-358.8-80.069 20.533-4.0529 41.753-9.3105 62.581-11.217 91.054-8.3228 193.03 22.203 231.87 49.462 38.668 27.155 38.666 57.85 21.225 78.192-59.327 69.171-425.42 107.11-520.61 111.02-779.62 6.6163-836.84 13.762-1188.7-55.955-55.238-10.94-178.02-30.164-179.45-80.557-0.402-14.33 7.9424-27.764 18.108-37.243 30.511-28.439 148.53-73.623 273.61-65.836 34.81 2.1602 62.038 12.903 74.653 9.1735-47.814-17.538-96.605-25.618-147.63-20.233-56.566 4.073-108.28 14.456-161.31 34.796-52.436 20.115-84.8 42.592-79.992 86.781 12.195 112.68 461.79 122.09 766.47 344.85zm130.77-60.555c9.4591-32.814 41.477-57.752 75.604-58.895 34.129-1.1433 67.742 21.598 79.376 53.704 11.634 32.106 0.3923 71.1-26.546 92.086-60.664 47.258-149.71-13.073-128.43-86.894z"/> <path d="m2144.1 1072c-17.055 10.109-39.195 22.039-50.85 38.478 9.5752-2.6443 19.964-11.34 29.244-15.738 39.436-18.681 111.6-28.681 154.92-35.997 353.47-59.704 443.56-7.5151 509.22 1.4799 19.748 2.7072 30.622-9.5172 28.517-24.678-1.3682-9.8292-9.3767-15.036-16.542-20.966-110.84-53.887-408.08-88.609-654.5 57.42z"/> <path d="m1090.1 1045.8c-1.8154 8.1259-0.2595 11.762 4.0474 18.454 38.256 15.782 127.84-35.64 292.15-34.008 100.03 0.9915 370.16 32.241 441.78 68.515 8.8021 4.4546 18.86 11.99 28.206 14.447-37.082-35.799-162.27-94.771-217.48-112.17-241.24-76.003-539.82 5.1167-548.7 44.758z"/> <path d="m2916.7 1337.3c32.437-83.069 59.942-177.91 49.08-267.88-11.39 18.255-22.648 32.549-41.305 44.229-73.168 45.806-169.18 63.471-250.88 90.936-251.74 84.645-532.19 230.6-645.07 485.8-18.011 40.726-29.356 82.392-39.663 125.58-2.5577 10.714-8.6753 28.939-6.7986 39.694l0.7018 2.3848c10.5-33.266 20.142-66.217 34.364-98.182 45.236-101.65 119.34-186.98 218.85-238.32 116.56-60.151 278.05-75.121 403.1-35.092-26.243-2.0034-51.715-6.4427-78.187-6.2141-240.84 2.0901-432.79 135.16-519.87 348.79-5.4563 13.389-14.879 29.534-16.318 43.874 11.315-12.702 17.925-34.583 27.24-49.37 33.063-52.488 82.032-100.95 135.86-132.01 86.481-49.91 205.04-66.995 301.73-41.418-16.989 1.2457-151.27-9.9421-290.41 90.005-228.41 164.09-218.04 490.05-231.34 570.77 40.986 2.3088 33.402 1.2173 68.684 9.3464 14.97-46.869 31.095-89.974 54.745-133.41 75.014-137.77 192.29-243.15 315.37-337.25 140.62-107.52 161.7-115.25 269.68-229.64 99.3-105.19 181.07-220.23 234.63-355.43 16.862-42.552 23.712-85.85 35.901-129.45-2.5779 169.51-153.72 417.75-280.49 544.82-207.98 208.47-514.97 351.26-587.71 661.68-62.489-34.222-158.47-32.416-221.51-0.2085-31.985-158.29-148.65-290.73-268.26-393.08-150.52-121.18-310.31-238.92-424.59-394.61-105.2-143.31-170.57-334.15-177.16-410.02-2.1103-2.7155-1.9833-6.7887-2.5321-10.16 2.2982 3.412 2.1 6.1528 2.5321 10.16 9.2965 19.164-2.0602-4.7192 36.612 111.71 184.3 511.9 643.26 568.7 833.42 955.67 17.345 35.295 33.104 73.102 41.723 111.6 61.276-13.004 55.812-9.4119 62.815-13.302-6.8191-190.48-45.719-405.91-191.91-540.68-62.362-57.486-144.54-97.82-228.4-111.41-31.085-5.0342-62.825-5.4614-94.246-5.5428 21.433-4.3322 43.385-9.387 65.144-11.482 90.63-8.7209 180.24 12.809 256.34 62.922 70.758 46.594 108.65 106.81 145.24 180.99 1.7544-9.4939-6.8496-26.63-10.526-35.728-20.335-50.326-44.062-97.388-75.009-142.05-113.91-164.39-313.18-234.77-470.33-221.49-17.62 1.4899-35.595 6.0818-53.194 6.3002 116.19-43.126 267.65-30.739 379.46 20.406 218.13 99.779 256.62 315.83 267.65 337.61-32.179-278.95-263.66-469.31-521.36-585.23l-144.69-56.678c-83.933-28.227-175.58-48.638-253.06-91.957-49.065-27.435-59.793-41.634-66.207-68.256-20.905 186.14 71.251 388.21 184.92 530.74 266.29 333.91 602.84 426.72 685.93 762.86 2.7612 11.156-5.212 24.377-8.7866 34.852-12.083 35.379 13.171 52.092 14.924 75.37 5.0056 66.451-20.639 191.1-107.76 327.01-96.381 150.34-245.19 256.34-375.55 374.64-241.77 219.39-451.98 519.88-377.95 862.8 92.015 426.23 640.58 798.15 1204.4 674.91 272.98-59.678 515.69-214.32 667.64-451.79 104-162.52 128.47-347.52 86.466-534-48.49-215.27-209.77-404.8-367.04-551.9-171.28-160.21-369.55-296.11-449.12-527.83-21.092-61.427-33.327-125.02-31.644-190.19 31.74-46.142 12.062-53.284 8.3445-76.814-5.0557-32.064 24.026-106.29 55.157-160.52 173.4-302.13 575.24-385.96 760.26-859.84zm-1840.1 2863.8c-44.6-102.85-85.815-193.02-87.025-317.12-4.6514-476.17 470.93-771.7 647.66-952.89 130.26-133.55 228.43-299.53 226.19-491.37 17.645 25.41 23.94 50.275 31.074 80.109 26.567 111.08 41.924 386.96 5.4309 622.14-88.922 572.94-334.91 548.16-600.97 743.17-101.79 74.618-201.1 187.62-221.06 316.05l-1.3017-0.0968zm775.48-663.2c-14.884 56.535-49.991 115.56-83.821 162.71-93.132 129.8-195.79 143.92-342.63 167.69l-0.6357-0.2136c10.796-13.366 203.51-53.319 330.77-187.71 40.212-42.465 65.515-93.458 96.32-142.48zm-628.91 796.66c-7.658 8.0547-17.767 28.023-26.371 31.954-5.451-11.584-6.1628-22.232-2.3442-34.476 13.335-42.776 66.968-95.715 103.54-117.99 90.773-55.29 205.63-63.385 300.67-111.21 257.09-129.37 309.32-516.35 312.49-524.82 3.7632 23.96-1.5 55.894-2.756 80.623-3.4476 67.798-4.6781 137.61-18.138 204.36-20.123 99.813-85.651 251.63-183.64 321.37-173.33 123.34-379.71 41.098-483.44 150.2zm1037.8 33.17c-252.36-74.905-274.27-226.5-299.56-291.74-8.0062 114.6-20.919 250.34-264.88 346.64-22.725 8.9697-45.425 18.525-68.984 25.059 122.54-67.684 137.12-88.341 187.09-136.67 122.98-136.13 120.3-285.03 111.55-448.24 8.7555 4.374 15.377 93.75 56.861 191.63 46.197 109 138.35 221.54 262.48 293.84 14.706 8.5635 32.763 16.028 45.694 26.798-9.9868-0.0152-20.686-4.4747-30.251-7.3174zm460.17 2.6289-8.8784 8.5483c-11.708-10.039-2.019-60.556-50.042-111.73-73.591-78.427-186.42-69.162-284.47-72.498-192.55-6.5449-309.75-102.7-354.91-232.88-46.134-132.99-50.092-416.05-45.598-556.68 9.9233 5.9683 12.271 210.63 64.651 356.72 38.671 107.86 112.37 204.84 213.56 260.53 41.967 23.096 86.237 37.685 132.62 48.862 115.12 27.736 283.78 44.11 334.43 191.75 11.919 34.746 14.94 73.763-1.3578 107.38zm-658.34-859.39c16.459 26.355 22.665 48.302 37.344 70.428 140.52 211.86 398.59 279.18 427.39 305.36-21.042-2.8123-45.44-14.33-66.049-20.706-98.314-30.418-187.11-59.555-266.88-127.85-56.418-48.308-94.292-104.93-118.12-175-5.6137-16.506-12.362-34.827-13.678-52.228zm844.31 143.89c40.878 124.09 47.229 267.33 11.589 393.38-16.755 59.262-41.47 107.23-66.013 157.5-25.578-195.37-193.04-310.88-351.43-401.73-109.71-62.934-231.45-117.15-339.37-275.27-95.837-140.41-123.81-317.39-140.69-483.26-16.425-161.39-19.893-335.64 11.182-495.41 21.187-108.97 27.402-102.19 36.857-108.54l5.6851 1.3882c6.1566 553.63 649.41 657.11 832.19 1211.9zm-830.87-1232.6c7.5027-2.3506 13.014-10.24 13.401-18.283 0.9463-19.648-17.852-30.334-36.336-36.76-66.597-23.153-143.39-18.933-204.41 16.406 14.593-16.116 32.877-28.869 53.042-36.996-54.59 8.8806-66.234 51.992-48.423 73.308-7.6631-5.4485-13.895-10.387-15.81-20.112-13.754-69.815 208.63-106.41 261.77-15.946-17.118-16.816-38.872-28.865-62.208-34.456 15.779 9.165 31.346 18.694 46.686 28.576 5.9832 3.855 12.294 8.2097 14.729 14.893 3.7907 10.405-2.7261 25.251-22.44 29.37z"/> <path d="m1419.2 2669.7c145.47-211.25-5.0316-488.91-255.41-491.72-197.98-2.2349-342.65 180.49-314.39 366.89 43.118 284.44 406.62 361.79 569.8 124.83zm-111.72 14.907c-124.87 95.643-311.45 42.553-369.58-101.17-68.074-168.33 60.8-328.65 216.39-332.59 101.27-2.5642 200.43 65.713 234.17 161.24 33.733 95.523-0.56 210.93-80.983 272.53z"/> <path d="m1274.7 2339.8c-112.25-78.129-251.6-12.361-284.6 99.034-49.853 168.31 152.68 307.86 292.19 200.81 89.43-68.624 105.75-220.95-7.596-299.85zm-4.8902 207.96c-7.6482 14.614-18.262 27.624-31.425 37.641-87.28 66.425-213.31-21.05-181.77-125.99 14.018-46.643 60.077-81.697 108.77-82.779 82.242-1.8279 148.91 86.127 104.42 171.13z"/> <path d="m2956.8 2489.1c-2.0366-78.432-58.686-153.34-134.95-175.95-75.753-22.458-164.28 8.8679-209.04 73.974-100.82 146.63 50.891 343.96 218.36 284.7 74.486-26.358 127.69-103.73 125.64-182.72zm-83.639 56.504c-13.138 25.857-35.571 47.113-62.849 57.132-101.9 37.426-196.03-82-135.46-172.35 26.879-40.1 80.733-59.879 127.18-46.707 62.259 17.657 106.47 92.392 71.136 161.93z"/> <path d="m1214 2430.2c-44.525-30.9-100.26-5.0012-113.18 39.957-19.286 67.09 61.603 121.86 116.73 78.846 35.947-28.047 40.592-88.175-3.5442-118.8z"/> <path d="m2791.9 2427.6c-31.108-13.378-68.914-0.7715-87.003 25.714-38.246 56 19.728 130.93 83.483 108.14 28.329-10.126 48.494-39.651 47.618-69.722-0.7981-27.408-19.018-53.346-44.098-64.131z"/> <path d="m125.96 4984.4c14.57 10.589 15.863 11.69 209.78 15.582h3428.4c18.115-2.0962 34.217-6.6538 43.904-15.938 22.378-21.456 24.44-68.672-19.419-106.18-61.142-52.287-111.76-37.977-347.57-35.829-3138 20.381-2986.5-14.31-3196.8-3.1631-128.99 13.128-163.43 112.56-118.27 145.53z"/>
            </svg>
            Visual Analytics Tool
        </a>

        <a role="button" class="navbar-burger" aria-label="menu" aria-expanded="false" data-target="navbarBasicExample">
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
        </a>
    </div>
    <div class="navbar-menu">
        <div class="navbar-start" id="timeSeriesNameTarget">

        </div>
    </div>
</nav>


<div class="file is-large is-boxed m-3 is-inline-block">
    <label class="file-label">
        Time Series file:
        <input id="timeSeriesFileInput" class="file-input" type="file" name="resume" />
        <span class="file-cta">
                    <span class="file-icon">
                        <i class="fas fa-upload"></i>
                    </span>
                    <span class="file-label"> Choose a file… </span>
                </span>
    </label>
</div>
<div class="file is-large is-boxed m-3 is-inline-block">
    <label class="file-label">
        Found Pattern file:
        <input id="foundPatternsFileInput" class="file-input" type="file" name="resume" />
        <span class="file-cta">
                    <span class="file-icon">
                        <i class="fas fa-upload"></i>
                    </span>
                    <span class="file-label"> Choose a file… </span>
                </span>
    </label>
</div>
<div class="file is-large is-boxed m-3 is-inline-block">
    <label class="file-label">
        Ground Truth file:
        <input id="groundTruthFileInput" class="file-input" type="file" name="resume" />
        <span class="file-cta">
                    <span class="file-icon">
                        <i class="fas fa-upload"></i>
                    </span>
                    <span class="file-label"> Choose a file… </span>
                </span>
    </label>
</div>
<div class="file is-large is-boxed m-3 is-inline-block">
    <label class="file-label">
        Meta Data file:
        <input id="metaDataFileInput" class="file-input" type="file" name="resume" />
        <span class="file-cta">
                    <span class="file-icon">
                        <i class="fas fa-upload"></i>
                    </span>
                    <span class="file-label"> Choose a file… </span>
                </span>
    </label>
</div>

<br>
<button id="demoButton" class="button m-3"> Use demo files to skip file upload. </button>

<div class="content">
    <div class="columns">
        <div class="card" id="glyphCard">
            <div id="algonameTarget"></div>
            <div class="is-flex">
                <div id="toggleShadowLineContainer">
                    <input id="toggleShadowLineSwitch" type="checkbox" name="toggleShadowLineSwitch"
                           class="switch is-rounded" checked="checked">
                    <label for="toggleShadowLineSwitch">Show Shadow Patterns</label>
                </div>
                <div class="select is-small mt-2 ml-auto is-rounded">
                    <select id="glyphTrackSelect">
                        <!-- populated in JS -->
                    </select>
                </div>
                <div class="select is-small mt-2 ml-auto is-rounded">
                    <select id="sortingselect">
                        <option name="occasc" value="chronAsc" selected="selected">Chronological, ascending</option>
                        <option name="occdes" value="chronDesc">Chronological, descending</option>
                        <option name="confasc" value="confAsc">Confidence, ascending</option>
                        <option name="confdes" value="confDesc">Confidence, descending</option>
                    </select>
                </div>
            </div>
            <div class="is-flex">
                <div id="toggleIDContainer">
                    <input id="toggleIDSwitch" type="checkbox" name="toggleIDSwitch"
                           class="switch is-rounded" checked="checked">
                    <label for="toggleIDSwitch">Show Glyph ID</label>
                </div>
            </div>
            <table id="glyphtable" class="table">
                <thead>
                <tr>
                    <th>
                        Glyph
                    </th>
                    <th style="text-align: right">
                        Confidence
                        <p id="confidenceThresholdHeader">Current Cutoff: </p>
                    </th>
                </tr>
                </thead>
            </table>
            <div id="glyphChartTarget">
            </div>
            <nav class="pagination is-rounded is-centered" role="navigation" aria-label="pagination">
                <a href="#" class="pagination-previous" id="paginationPrevious">Previous</a>
                <a href="#" class="pagination-next" id="paginationNext">Next Page</a>
                <ul class="pagination-list mt-0 ml-0" id="paginationTarget">
                </ul>
            </nav>
            <div class="box">
                <p class="subtitle is-5 mb-0">Legend.</p>
                <div id="legendTarget"></div>
            </div>
        </div>
        <div class="column">
            <div class="columns">
                <div class="column">
                    <div class="columns">
                        <div class="column">
                            <div class="tabs is-centered is-fullwidth">
                                <ul>
                                    <li class="is-active" id="confTabList"><a id="confTabButton">Confidence Distribution</a></li>
                                    <li id="scoreTabList"><a id="scoreTabButton">Glyph Score Scatter Plot</a></li>
                                </ul>
                            </div>
                            <div id="histogramContainer">
                                <div class="ml-5 mt-5">
                                    <p class="subtitle is-5 mb-0">Confidence distribution</p>
                                    <p class="subtitle is-6 mb-2">Use this histogram to select the confidence cutoff</p>
                                </div>
                                <div class="ml-5">
                                    <div id="histoTarget">
                                    </div>
                                </div>
                            </div>
                            <div style="display: none" id="scatterplotContainer" class="ml-5">
                                <p class="subtitle is-5 mb-0">Glyph Scatter Plot</p>
                                <p class="subtitle is-6 mb-2">Use this scatter plot to filter glyphs</p>
                                <div id="scatterPlotTarget">
                                </div>
                            </div>
                        </div>
                        <div class="column">
                            <div class="mt-5">
                                <p class="subtitle is-5 mb-0">Line graph track selection</p>
                                <p class="subtitle is-6 mb-2">Select tracks to be shown in line graph. <br> Use ctrl/command or shift to select multiple tracks.</p>
                            </div>
                            <div class="select is-multiple">
                                <label for="trackSelector"></label><select id="trackSelector">
                                <!-- populated in javascript -->
                            </select>
                            </div>
                            <button id="trackSelectorButton" class="button is-success">
                            <span class="icon is-small">
                              <i class="fas fa-check"></i>
                            </span>
                                <span>Save</span>
                            </button>
                        </div>
                    </div>
                    <div class="ml-5 mt-5">
                        <p class="subtitle is-5 mb-0 is-inline-block">Time Series</p>
                        <button id="resetZoomButton" class="button is-small ml-4 mb-1 is-rounded">Reset Zoom</button>
                    </div>
                    <div class="ml-5">
                        <div id="miniMapTarget">
                        </div>
                    </div>
                    <div class="ml-4">
                        <div id="lineGraphTarget">
                        </div>
                    </div>
                </div>
                <div class="column">
                </div>
            </div>
        </div>
    </div>
</div>

<svg  height="0" width="0" xmlns="http://www.w3.org/2000/svg" version="1.1">
    <defs>
        <pattern id="diagonalHatch" patternUnits="userSpaceOnUse" width="8" height="8">
            <rect width="8" height="8" fill="#a6cee3"></rect>
            <path d="M-1,1 l2,-2
                        M0,8 l8,-8
                        M7,9 l2,-2"
                  style="stroke:#1f78b4; stroke-width:2.5;"/>
        </pattern>
    </defs>
</svg>

<!-- Tooltips HTML -->
<div id="tooltipdiv" class="arrow_box"></div>
<div id="lineGraphTooltipDiv" class="arrow_box"></div>
<div id="scatterPlotTooltipDiv" class="arrow_box"></div>

</body>
</html>